
from Point import *
from Force import *

####
# Mass Object
# Comp-304 : Winter 2007
#
# A mass is composed of a weight and a position. It has multiple
# forces applied to it. For convience, we give it a name.
####

class Mass:
           
    ###
    # Creates an object of the given name, at the given location, 
    # of the given weight.
    ###
    def __init__(self, name, weight, position):
        
        if not isinstance(name, str):
            raise TypeError
        
        if not isinstance(weight, float) and not isinstance(weight, int):
            raise TypeError

        if type(position) != type(Point()):
            raise TypeError        
        
        self.name = name
        self.weight = weight
        self.position = position
        self.forces = []
       
    ### 
    # Applies the given force to the object.
    ###
    def applyForce(self, force):        
        
        if type(force) != type(Force()):
            raise TypeError
        
        self.forces.append(force)
       
    ###
    # Removes the given force from the object.
    ###
    def removeForce(self, force):
        
        if type(force) != type(Force()):
            raise TypeError
        
        self.forces.remove(force)
    
    ###
    # Returns true if this mass is the same as the provided mass.
    ###
    def equals(self, force):
        
        if type(force) != type(Force()):
            raise TypeError
        
        print "You must implement this as part of your assignment."
        
    ###
    # Returns a string representation of this object.
    ###
    def __str__(self):
        strVal = "Mass " + self.name + " of weight " + str(self.weight) 
        strVal +=" at localtion " + str(self.position) + "with forces:"
        
        for force in self.forces:
            strVal += "\n" + str(force)
        
        return strVal
