
####
# Point
# Comp-304 : Winter 2007
#
# Indicates a location in a 2D cartesian system.
####

class Point:
    
    ###
    # Creates a (x,y) point.
    ###        
    def __init__(self, x = 0, y = 0):
                
        if not isinstance(x, float) and not isinstance(x, int):
            raise TypeError
        
        if not isinstance(y, float) and not isinstance(y, int):
            raise TypeError
        
        self.x = x
        self.y = y
       
    ###
    # Returns a new point which is the addition of this Point and the provided
    # point.
    ###
    def add(self, point):
        
        if type(point) != type(self):
            raise TypeError
        
        return Point(self.x + point.x, self.y + point.y)
    
    ###
    # Returns a new point which is the subtraction of this Point and the 
    # provided point.
    ###
    def subtract(self, point):
        
        if type(point) != type(self):
            raise TypeError
                
        return Point(self.x - point.x, self.y - point.y)
        
    ###
    # Returns true if this point is equal to the provided point.
    ###
    def equal(self, point):
        
        if type(point) != type(self):
            raise TypeError
        
        if self.x == point.x:
            if self.y == point.y:
                return True            
        return False
    
    ###
    # Returns a string representation of this object.
    ###
    def __str__(self):
        return "Point (" + str(self.x) + "," + str(self.y) + ")"
