
####
# Vector
# Comp-304 : Winter 2007
#
# Indicates a vector (magnitude, direction) in a 2D cartesian system.
####

class Vector:
   
    ###
    # Creates a vector using the given x,y
    ### 
    def __init__(self, x = 0, y = 0):
        
        if not isinstance(x, float) and not isinstance(x, int):
            raise TypeError
        
        if not isinstance(y, float) and not isinstance(y, int):
            raise TypeError        
        
        self.x = x
        self.y = y
       
    ###
    # Returns a vector representing the addition of this vector and the
    # provided vector.
    ### 
    def add(self, vector):
        
        if type(vector) != type(self):
            raise TypeError
        
        return Vector(self.x + vector.x, self.y + vector.y)
    
    ###
    # Returns a vector representing the subtraction of this vector and the
    # provided vector.
    ###
    def subtract(self, vector):
        
        if type(vector) != type(self):
            raise TypeError
        
        return Vector(self.x - vector.x, self.y - vector.y)
            
    ###
    # Returns a vector pointing in the opposite direction (-x,-y)
    ###
    def opposite(self):
                
        return Vector(-self.x, -self.x)
    
    ###
    # Returns the scalar product of this vector and the given value.
    ###
    def scalarMultiply(self, value):
        
        if not isinstance(value, float) and not isinstance(value, int):
            raise TypeError
        
        return Vector(-self.x*value, -self.y*value)
    
    ###
    # Returns the scalar division of this vector and the given value.
    ###
    def scalarDivide(self, value):
        
        if not isinstance(value, float) and not isinstance(value, int):
            raise TypeError
        
        return Vector(self.x/value, self.y/value)
        
    ###
    # Returns the dot product of this vector and the given value.
    ###
    def dotProduct(self, vector):
        
        return "You must implement this as part of your assignment."
    
    ###
    # Returns the cross product of this vector and the given value.
    ###
    def crossProduct(self, vector):        
        
        return "You must implement this as part of your assignment."

    ###
    # Returns the unit vector of this vector.
    ###
    def unit(self):
        
        return "You must implement this as part of your assignment."                
    
    ###
    # Returns a copy of this object.
    ###        
    def clone(self):
        return Vector(self.x, self.y)
    
    ###
    # Returns true if this vector is equal to the provided vector.
    ###
    def equal(self, vector):
        
        if type(vector) != type(self):
            raise TypeError  
        
        if self.x == vector.x:
            if self.y == vector.y:
                return True
        return False
    
    
    ###
    # Returns a string representation of this object.
    ###
    def __str__(self):
        return "Vector (" + str(self.x) + "," + str(self.y) + ")"